#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"fft.h"

typedef long INT32;
typedef unsigned short int INT16;
typedef unsigned char U_CHAR;

#define UCH(x)	((int) (x))
#define GET_2B(array,offset)  ((INT16) UCH(array[offset]) + \
			       (((INT16) UCH(array[offset+1])) << 8))
#define GET_4B(array,offset)  ((INT32) UCH(array[offset]) + \
			       (((INT32) UCH(array[offset+1])) << 8) + \
			       (((INT32) UCH(array[offset+2])) << 16) + \
			       (((INT32) UCH(array[offset+3])) << 24))
#define FREAD(file,buf,sizeofbuf)  \
  ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))

int ReadDataSize(char *name);
void ReadImageData(char *name, U_CHAR *bmpfileheader, U_CHAR *bmpinfoheader, U_CHAR *color_table, U_CHAR *data);


int main()
{
   FILE *output_file = 0 ;
   
   U_CHAR bmpfileheader1[14] = { 0 } ;
   U_CHAR bmpinfoheader1[40] = { 0 } ;
   U_CHAR *data1, *data2, color_table1[1024];
   COMPLEX *c, *c2, *c3;

 
   INT32 biWidth = 0 ;		
   INT32 biHeight = 0 ;

   int i, j, k, k2, temp, temp1, temp2;
   int histo_table[256] = { 0 };
   double max, min, scale, D, H, d_real, d_imag, W, D02;
   int D0=5, n=4;
   int pass_x=3, pass_y=3;


   //i = ReadDataSize("Fig5.19(a).bmp");   
   i = ReadDataSize("noise_row.bmp");
   //i = ReadDataSize("impulse.bmp");
   //i = ReadDataSize("Fig5.16(a).bmp");   
   data1 = (U_CHAR *)malloc( i );
   if (data1 == NULL) {
      exit(0);
   }
  
   data2 = (U_CHAR *)malloc( i );
   if (data2 == NULL) {
      exit(0);
   }

   //ReadImageData("Fig5.19(a).bmp", bmpfileheader1, bmpinfoheader1, color_table1, data1);
   ReadImageData("noise_row.bmp", bmpfileheader1, bmpinfoheader1, color_table1, data1);
   //ReadImageData("impulse.bmp", bmpfileheader1, bmpinfoheader1, color_table1, data1);
   //ReadImageData("Fig5.16(a).bmp", bmpfileheader1, bmpinfoheader1, color_table1, data1);
   biWidth           =   GET_4B(bmpinfoheader1,4);
   biHeight          =   GET_4B(bmpinfoheader1,8);


   c = (COMPLEX *)malloc( 2*biHeight*2*biWidth*sizeof(COMPLEX) );
   if (c == NULL) {
      exit(0);
   }
   c2 = (COMPLEX *)malloc( 2*biHeight*2*biWidth*sizeof(COMPLEX) );
   if (c2 == NULL) {
      exit(0);
   }
   c3 = (COMPLEX *)malloc( biHeight*biWidth*sizeof(COMPLEX) );
   if (c2 == NULL) {
      exit(0);
   }

   // Process the file
   // Padding 0
   for (i=0; i < 2*biHeight*2*biWidth; i++)
   {
	   c[i].real = 0.0;
	   c[i].imag = 0.0;
   }

   // Filling data
   // Bottom-up
   for (i=0; i < biHeight; i++)
   {
       k = (biHeight-1-i)* ((biWidth*1 +3)/4 *4);
	   k2 = i*2*biWidth;
       for (j=0; j < biWidth; j++)
       {
		   c[k2].real = data1[k];
		   c[k2].imag = 0.0;
		   //if ((i+j)%2 == 1)
		   //		c[k2].real = 0.0-c[k2].real;

           k = k+1;
		   k2 = k2+1;
       }
   }

   if (!FFT2D(c, 2*biHeight, 2*biWidth, 1))
   {
	   printf("Stop!\n");
	   exit(0);
   }

   // -------------------------
	// Filter
   // Specify the filter
	for (i=0; i < biHeight; i++)
    {
       k = i* ((biWidth*1 +3)/4 *4);
       for (j=0; j < biWidth; j++)
       {
		   temp = (int) sqrt((j-biWidth/2)*(j-biWidth/2) + (i-biHeight/2)*(i-biHeight/2));

		   // Page244, Bandreject filters
		   W = 6;
		   D02 = 50*50;
		   c3[k].real = 1/(1+pow(temp*W/(temp*temp-D02),2));
		   c3[k].imag = 0;

		   // Page 249, Notch pass filters
           c3[k].real = 0;
		   if (abs(j-biWidth/2) < 1 && abs(i-biHeight/2) > 50)
				c3[k].real = 1;
   		   
		   if ((i+j)%2 == 1)
		   {
				c3[k].real = 0.0-c3[k].real;
				c3[k].imag = 0.0-c3[k].imag;
		   }

           k = k+1;
       }
   }

	// inverse transform
  
   
   if (!FFT2D(c3, biHeight, biWidth, -1))
   {
	   printf("Stop!\n");
	   exit(0);
   }

   
   // (-1)^(x+y)
   for (i=0; i < biHeight; i++)
   {
 	   k2 = i*biWidth;
       for (j=0; j < biWidth; j++)
       {
		   if ((i+j)%2 == 1)
		   {
				c3[k2].real = 0.0-c3[k2].real;
				c3[k2].imag = 0.0-c3[k2].imag;
		   }
           k2 = k2+1;
       }
   }

   // padding 0
   for (i=0; i < 2*biHeight*2*biWidth; i++)
   {
	   c2[i].real = 0.0;
	   c2[i].imag = 0.0;
   }

   // copy filter
   for (i=0; i < biHeight; i++)
   {
       k = i*biWidth;
	   k2 = i*2*biWidth;
       for (j=0; j < biWidth; j++)
       {
		   c2[k2].real = c3[k].real;
		   c2[k2].imag = c3[k].imag;
           k = k+1;
		   k2 = k2+1;
       }
   }


   // forward transform
   if (!FFT2D(c2, 2*biHeight, 2*biWidth, 1))
   {
	   printf("Stop!\n");
	   exit(0);
   }



   
   // -------------------------
	// H(u,v)*G(v,v)
   for (i=0; i < 2*biHeight*2*biWidth; i++)
   {
	   d_real = c[i].real*c2[i].real - c[i].imag*c2[i].imag;
	   d_imag = c[i].real*c2[i].imag + c[i].imag*c2[i].real;
	   c[i].real = d_real;
	   c[i].imag = d_imag;
   }



	// -----------------------------

   // (-1)^(u+v)
/*   for (i=0; i < 2*biHeight; i++)
   {
 	   k2 = i*2*biWidth;
       for (j=0; j < 2*biWidth; j++)
       {
		   if ((i+j)%2 == 1)
		   {
				c[k2].real = 0.0-c[k2].real;
				c[k2].imag = 0.0-c[k2].imag;
		   }
           k2 = k2+1;
       }
   }
*/

   
   if (!FFT2D(c, 2*biHeight, 2*biWidth, -1))
   {
	   printf("Stop!\n");
	   exit(0);
   }

   
   // Move data from the center to the up-left part
   for (i=0; i < 2*biHeight*2*biWidth; i++)
   {
	   c2[i].real = c[i].real;
	   c2[i].imag = c[i].imag;
   }
   temp1 = 2*biHeight;
   temp2 = 2*biWidth;
   for (i=0; i < 2*biHeight; i++)
   {
       for (j=0; j < 2*biWidth; j++)
	   {
		   k = i*2*biWidth+j;
		   k2 = ((i+biHeight/2)%temp1)*2*biWidth+ (j+biWidth/2)%temp2;
		   c[k].real = c2[k2].real;
		   c[k].imag = c2[k2].imag;
	   }
   }


   // find the maximum
   max = 0.0;
   min = 255.0;
   for (i=0; i < biHeight; i++)
   {
 	   k2 = i*2*biWidth;
       for (j=0; j < biWidth; j++)
       {
		   if (c[k2].real > max)
			   max = c[k2].real;
		   if (c[k2].real < min)
			   min = c[k2].real;

           k2 = k2+1;
       }
   }
   printf("max=%f\n", max);
   printf("min=%f\n", min);
   //
   scale = 255.0/(max-min);
   // Bottom-up
   for (i=0; i < biHeight; i++)
   {
       k = (biHeight-1-i)* ((biWidth*1 +3)/4 *4);
 	   k2 = i*2*biWidth;
       for (j=0; j < biWidth; j++)
       {
		   temp = (int) ((c[k2].real-min)*scale);
		   if (temp > 255)	temp = 255;
		   if (temp < 0) temp = 0;
		   data2[k] = (U_CHAR) temp;

           k = k+1;
           k2 = k2+1;
       }
   }


   //
   /* }ҷsɮ */
   if( ( output_file = fopen("new6.bmp","wb") ) == NULL ){
      fprintf(stderr,"Output file can't open.\n");
      exit(0);
   }

   fwrite(bmpfileheader1, sizeof(bmpfileheader1), 1, output_file);
   fwrite(bmpinfoheader1, sizeof(bmpinfoheader1), 1, output_file);

   fwrite(color_table1, 1024, 1, output_file);
 
   fwrite(data2, ((biWidth*1 +3)/4 *4)*biHeight*1, 1, output_file);
 
   fclose (output_file);

   free(data1);
   free(data2);
   free(c);
   free(c2);
   free(c3);

  
   return 0;
}

int ReadDataSize(char *name)
{
   FILE *input_file = 0 ;
   U_CHAR bmpfileheader[14] = { 0 } ;
   U_CHAR bmpinfoheader[40] = { 0 } ;
   
   INT32 biWidth = 0 ;		
   INT32 biHeight = 0 ;
   INT16 BitCount = 0 ;

   /* }ɮ */
   if( ( input_file = fopen(name,"rb") ) == NULL ){
      fprintf(stderr,"File can't open.\n");
      exit(0);
   }

   FREAD(input_file,bmpfileheader,14);
   FREAD(input_file,bmpinfoheader,40);

   if (GET_2B(bmpfileheader,0) == 0x4D42) /* 'BM' */
      fprintf(stdout,"BMP file.\n");
   else{
      fprintf(stdout,"Not bmp file.\n");
      exit(0);
   }

   biWidth           =   GET_4B(bmpinfoheader,4);
   biHeight          =   GET_4B(bmpinfoheader,8);
   BitCount          =   GET_2B(bmpinfoheader,14);

   if (BitCount != 8) {
      fprintf(stderr,"Not a 8-bit file.\n");
      fclose (input_file);
      exit(0);
   }

   // 
   fclose (input_file);

   return ((biWidth*1 +3)/4 *4)*biHeight*1;
}

void ReadImageData(char *name, U_CHAR *bmpfileheader, U_CHAR *bmpinfoheader, U_CHAR *color_table, U_CHAR *data)
{
   FILE *input_file = 0 ;
   
   INT32 FileSize = 0 ;
   INT32 bfOffBits =0 ;
   INT32 headerSize =0 ;
   INT32 biWidth = 0 ;		
   INT32 biHeight = 0 ;
   INT16 biPlanes = 0 ;
   INT16 BitCount = 0 ;
   INT32 biCompression = 0 ;
   INT32 biImageSize = 0;
   INT32 biXPelsPerMeter = 0 ,biYPelsPerMeter = 0 ;
   INT32 biClrUsed = 0 ;
   INT32 biClrImp = 0 ;

   /* }ɮ */
   if( ( input_file = fopen(name,"rb") ) == NULL ){
      fprintf(stderr,"File can't open.\n");
      exit(0);
   }

   FREAD(input_file,bmpfileheader,14);
   FREAD(input_file,bmpinfoheader,40);

   if (GET_2B(bmpfileheader,0) == 0x4D42) /* 'BM' */
      fprintf(stdout,"BMP file.\n");
   else{
      fprintf(stdout,"Not bmp file.\n");
      exit(0);
   }

   FileSize           =   GET_4B(bmpfileheader,2);
   bfOffBits         =   GET_4B(bmpfileheader,10);
   headerSize      =   GET_4B(bmpinfoheader,0);
   biWidth           =   GET_4B(bmpinfoheader,4);
   biHeight          =   GET_4B(bmpinfoheader,8);
   biPlanes          =   GET_2B(bmpinfoheader,12);
   BitCount          =   GET_2B(bmpinfoheader,14);
   biCompression   =   GET_4B(bmpinfoheader,16);
   biImageSize      =   GET_4B(bmpinfoheader,20);
   biXPelsPerMeter =   GET_4B(bmpinfoheader,24);
   biYPelsPerMeter =   GET_4B(bmpinfoheader,28);
   biClrUsed         =   GET_4B(bmpinfoheader,32);
   biClrImp          =   GET_4B(bmpinfoheader,36);

   printf("FileSize = %ld \n"
	"DataOffset = %ld \n"
           "HeaderSize = %ld \n"
	"Width = %ld \n"
	"Height = %ld \n"
	"Planes = %d \n"
	"BitCount = %d \n"
	"Compression = %ld \n"
	"ImageSize = %ld \n"
	"XpixelsPerM = %ld \n"
	"YpixelsPerM = %ld \n"
	"ColorsUsed = %ld \n"
	"ColorsImportant = %ld \n",FileSize,bfOffBits,headerSize,biWidth,biHeight,biPlanes,
	BitCount,biCompression,biImageSize,biXPelsPerMeter,biYPelsPerMeter,biClrUsed,biClrImp);

   if (BitCount != 8) {
      fprintf(stderr,"Not a 8-bit file.\n");
      fclose (input_file);
      exit(0);
   }

   FREAD(input_file,color_table,1024);

   //
   
   //
   fseek(input_file,bfOffBits,SEEK_SET);
   FREAD(input_file,data,((biWidth*1 +3)/4 *4)*biHeight*1);
   // 
   fclose (input_file);
}

//void padding(